unit UGrafico;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UPadrao, Db, ADODB, ExtCtrls, TeeProcs, TeEngine, Chart, DBChart,
  printers, StdCtrls, Buttons, JvLookup, Series, DBTables, JvSpin, Mask, DBCtrls,
  qrprgres, Menus, JvExMask, JvExControls, JvComponent, JvSpeedButton, ;

type
  TFrmGrafico = class(TForm)
    qry: TADOQuery;
    DBChart1: TDBChart;
    Series1: TBarSeries;
    qryLookNucleo: TStringField;
    qrycodNucleo: TIntegerField;
    qryElaborados: TIntegerField;
    Series2: TBarSeries;
    SaveDialog1: TSaveDialog;
    btnSalvar: TBitBtn;
    Label1: TLabel;
    EdtAno: TJvSpinEdit;
    qryTotal: TADOQuery;
    qryTotalTotalElaborados: TFloatField;
    qryTotalTotalLiberados: TFloatField;
    PrintDialog1: TPrintDialog;
    qryLiberados: TIntegerField;
    btnAtualizar: TButton;
    CheckBox1: TCheckBox;
    btnPrint: TJvSpeedButton;
    PopupMenu1: TPopupMenu;
    Grfico1: TMenuItem;
    Relatrio1: TMenuItem;
    btnPrior: TSpeedButton;
    btnNext: TSpeedButton;
    btnFirst: TSpeedButton;
    btnLast: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure btnSalvarClick(Sender: TObject);
    procedure btnAtualizarClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure EdtAnoKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Relatrio1Click(Sender: TObject);
    procedure Grfico1Click(Sender: TObject);
    procedure btnFirstClick(Sender: TObject);
    procedure DBChart1PageChange(Sender: TObject);
  private
    { Private declarations }
    PrintCanceled: Boolean;
    procedure PrintCancel(Sender: TObject);
  public
    { Public declarations }
  end;

var
  FrmGrafico: TFrmGrafico;

implementation

uses UDataModule, URelGrafElabLibNucleo, USalvarGrafico;

{$R *.DFM}

procedure TFrmGrafico.FormCreate(Sender: TObject);
begin
  inherited;
  edtAno.Text := FormatDateTime('yyyy',date);
  btnAtualizar.Click;
  Constraints.MinWidth := Screen.Width;
  Constraints.MinHeight := Screen.Height;
  top:=0;
  left:= 0;
end;

procedure TFrmGrafico.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  inherited;
  qry.close;
  FrmGrafElabLib:= nil;
end;

procedure TFrmGrafico.FormShow(Sender: TObject);
begin
  inherited;
  WindowState := wsMaximized;
end;

procedure TFrmGrafico.btnSalvarClick(Sender: TObject);
begin
  TFrmSalvarGrafico.Execute(DBChart1);
end;

procedure TFrmGrafico.btnAtualizarClick(Sender: TObject);
begin
  inherited;
  try
    screen.cursor:= crHourGlass;
    qry.close;
    qryTotal.close;
    qry.Parameters.ParamByName('[pAno]').value:= StrToInt(edtAno.text);
    qryTotal.Parameters.ParamByName('[pAno]').value:= StrToInt(edtAno.text);
    qryTotal.open;
    qry.open;
    btnFirst.click;
    DBChart1.Title.Text.Text:=
      'Projetos Elaborados e Liberados por Ncleo - '+edtAno.text+#13;

    DBChart1.Foot.Text.Text:=
      'Total de Elaborados: '+qryTotalTotalElaborados.text
      + #13'Total de Liberados: '+qryTotalTotalLiberados.text;
    DBChart1.Foot.Text.Add('');
    DBChart1.Foot.Text.Add('');
    DBChart1.Foot.Text.Add(
       'Pgina ' + IntToStr(DBChart1.Page) + ' de ' + IntToStr(DBChart1.NumPages));
  finally
    screen.cursor:= crDefault;
  end;
end;

procedure TFrmGrafico.btnSairClick(Sender: TObject);
begin
  inherited;
  close;
end;

procedure TFrmGrafico.CheckBox1Click(Sender: TObject);
begin
  inherited;
  DBChart1.Monochrome := CheckBox1.Checked;
end;

procedure TFrmGrafico.EdtAnoKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  inherited;
  if EdtAno.Text = '' then
  begin
     EdtAno.AsInteger := trunc(EdtAno.MinValue);
     EdtAno.SelStart := EdtAno.GetTextLen;
  end;
end;

procedure TFrmGrafico.Relatrio1Click(Sender: TObject);
begin
  inherited;
  with TQRepGrafElabLibNucleo.create(self) do
  try
     lbTitulo.caption:= 'Relatrio do Grfico de Projetos Elaborados e Liberados por Ncleo - ' + edtAno.text;
     PreviewModal;
  finally
     free;
  end;
end;

procedure TFrmGrafico.Grfico1Click(Sender: TObject);
//i = inicio, f = fim, x  o contador, origem  em qual pgina estava antes da impresso
//h = heigth, w = width (utilizadas pra definar as margens da impresso
var h, w, x, i, f, origem: longint;
begin
   inherited;
   btnPrint.Enabled := false;
   try
     PrintDialog1.FromPage := 1;
     PrintDialog1.MaxPage := DBChart1.NumPages;
     PrintDialog1.ToPage := DBChart1.NumPages;
     if PrintDialog1.execute then
     begin
       if PrintDialog1.PrintRange = prAllPages then
       begin
         i:= 1;
         f:= PrintDialog1.MaxPage;
       end
       else
       begin
         i:= PrintDialog1.FromPage;
         f:= PrintDialog1.ToPage;
       end;
       origem:= DBChart1.Page;

       with TQRProgressForm.Create(self) do
       try
         Printer.Orientation := poLandscape;
         Printer.BeginDoc;

         CancelButton.OnClick :=  PrintCancel;
         CancelButton.Cancel := true;
         Show;
         gauge.Max := f - i + 1;
         gauge.Position := 0;
         for x:= i to f do
         begin
            Gauge.StepBy(1);
            if PrintCanceled then
               break;
            DBChart1.Page := x;
            try
              h:=Printer.PageHeight;
              w:=Printer.PageWidth;
              DBChart1.PrintPartial(Rect(10,15,w - 15,h - 15) );
              Printer.NewPage;
            except
              on Exception do
              Begin
                Printer.Abort;
                Printer.EndDoc;
                Raise;
              end;
            end;
         end;
         Printer.EndDoc;
       finally
         DBChart1.Page:= origem;
         PrintCanceled:= false;
         free;
       end;
     end;
   finally
     btnPrint.Enabled := true;
   end;
end;

procedure TFrmGrafico.PrintCancel(Sender: TObject);
begin
   PrintCanceled:= true;
end;

procedure TFrmGrafico.btnFirstClick(Sender: TObject);
begin
  inherited;
  if sender = btnPrior then
    DBChart1.PreviousPage
  else if sender = btnNext then
     DBChart1.NextPage
  else if sender = btnFirst then
     DBChart1.Page := 1
  else if sender = btnLast then
     DBChart1.Page := DBChart1.NumPages;
  btnPrior.enabled:= (DBChart1.Page > 1);
  btnNext.enabled:= (DBChart1.Page < DBChart1.NumPages);
  btnFirst.enabled:= btnPrior.enabled;
  btnLast.enabled:= btnNext.Enabled;
end;

procedure TFrmGrafico.DBChart1PageChange(Sender: TObject);
begin
  inherited;
  DBChart1.Foot.Text.Text:=
    'Total de Elaborados: '+qryTotalTotalElaborados.text
    + #13'Total de Liberados: '+qryTotalTotalLiberados.text;
  DBChart1.Foot.Text.Add('');
  DBChart1.Foot.Text.Add('');
  DBChart1.Foot.Text.Add(
    'Pgina ' + IntToStr(DBChart1.Page) + ' de ' + IntToStr(DBChart1.NumPages));
end;

end.
